/**
 * ORY Keto
 * A cloud native access control server providing best-practice patterns (RBAC, ABAC, ACL, AWS IAM Policies, Kubernetes Roles, ...) via REST APIs.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.sh
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AddOryAccessControlPolicyRoleMembersBody', 'model/AuthorizationResult', 'model/InlineResponse500', 'model/OryAccessControlPolicy', 'model/OryAccessControlPolicyAllowedInput', 'model/OryAccessControlPolicyRole'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AddOryAccessControlPolicyRoleMembersBody'), require('../model/AuthorizationResult'), require('../model/InlineResponse500'), require('../model/OryAccessControlPolicy'), require('../model/OryAccessControlPolicyAllowedInput'), require('../model/OryAccessControlPolicyRole'));
  } else {
    // Browser globals (root is window)
    if (!root.OryKeto) {
      root.OryKeto = {};
    }
    root.OryKeto.EnginesApi = factory(root.OryKeto.ApiClient, root.OryKeto.AddOryAccessControlPolicyRoleMembersBody, root.OryKeto.AuthorizationResult, root.OryKeto.InlineResponse500, root.OryKeto.OryAccessControlPolicy, root.OryKeto.OryAccessControlPolicyAllowedInput, root.OryKeto.OryAccessControlPolicyRole);
  }
}(this, function(ApiClient, AddOryAccessControlPolicyRoleMembersBody, AuthorizationResult, InlineResponse500, OryAccessControlPolicy, OryAccessControlPolicyAllowedInput, OryAccessControlPolicyRole) {
  'use strict';

  /**
   * Engines service.
   * @module api/EnginesApi
   * @version Latest
   */

  /**
   * Constructs a new EnginesApi. 
   * @alias module:api/EnginesApi
   * @class
   * @param {module:ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the addOryAccessControlPolicyRoleMembers operation.
     * @callback module:api/EnginesApi~addOryAccessControlPolicyRoleMembersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OryAccessControlPolicyRole} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a member to an ORY Access Control Policy Role
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {Object} opts Optional parameters
     * @param {module:model/AddOryAccessControlPolicyRoleMembersBody} opts.body 
     * @param {module:api/EnginesApi~addOryAccessControlPolicyRoleMembersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OryAccessControlPolicyRole}
     */
    this.addOryAccessControlPolicyRoleMembers = function(flavor, id, opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling addOryAccessControlPolicyRoleMembers");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling addOryAccessControlPolicyRoleMembers");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = OryAccessControlPolicyRole;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles/{id}/members', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteOryAccessControlPolicy operation.
     * @callback module:api/EnginesApi~deleteOryAccessControlPolicyCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete an ORY Access Control Policy
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {module:api/EnginesApi~deleteOryAccessControlPolicyCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteOryAccessControlPolicy = function(flavor, id, callback) {
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling deleteOryAccessControlPolicy");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling deleteOryAccessControlPolicy");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/policies/{id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteOryAccessControlPolicyRole operation.
     * @callback module:api/EnginesApi~deleteOryAccessControlPolicyRoleCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete an ORY Access Control Policy Role
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {module:api/EnginesApi~deleteOryAccessControlPolicyRoleCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteOryAccessControlPolicyRole = function(flavor, id, callback) {
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling deleteOryAccessControlPolicyRole");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling deleteOryAccessControlPolicyRole");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles/{id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the doOryAccessControlPoliciesAllow operation.
     * @callback module:api/EnginesApi~doOryAccessControlPoliciesAllowCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AuthorizationResult} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Check if a request is allowed
     * Use this endpoint to check if a request is allowed or not. If the request is allowed, a 200 response with &#x60;{\&quot;allowed\&quot;:\&quot;true\&quot;}&#x60; will be sent. If the request is denied, a 403 response with &#x60;{\&quot;allowed\&quot;:\&quot;false\&quot;}&#x60; will be sent instead.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {Object} opts Optional parameters
     * @param {module:model/OryAccessControlPolicyAllowedInput} opts.body 
     * @param {module:api/EnginesApi~doOryAccessControlPoliciesAllowCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AuthorizationResult}
     */
    this.doOryAccessControlPoliciesAllow = function(flavor, opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling doOryAccessControlPoliciesAllow");
      }


      var pathParams = {
        'flavor': flavor
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AuthorizationResult;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/allowed', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getOryAccessControlPolicy operation.
     * @callback module:api/EnginesApi~getOryAccessControlPolicyCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OryAccessControlPolicy} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get an ORY Access Control Policy
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {module:api/EnginesApi~getOryAccessControlPolicyCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OryAccessControlPolicy}
     */
    this.getOryAccessControlPolicy = function(flavor, id, callback) {
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling getOryAccessControlPolicy");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getOryAccessControlPolicy");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = OryAccessControlPolicy;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/policies/{id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getOryAccessControlPolicyRole operation.
     * @callback module:api/EnginesApi~getOryAccessControlPolicyRoleCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OryAccessControlPolicyRole} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get an ORY Access Control Policy Role
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {module:api/EnginesApi~getOryAccessControlPolicyRoleCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OryAccessControlPolicyRole}
     */
    this.getOryAccessControlPolicyRole = function(flavor, id, callback) {
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling getOryAccessControlPolicyRole");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling getOryAccessControlPolicyRole");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = OryAccessControlPolicyRole;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles/{id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listOryAccessControlPolicies operation.
     * @callback module:api/EnginesApi~listOryAccessControlPoliciesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/OryAccessControlPolicy>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List ORY Access Control Policies
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit The maximum amount of policies returned.
     * @param {Number} opts.offset The offset from where to start looking.
     * @param {String} opts.subject The subject for whom the policies are to be listed.
     * @param {String} opts.resource The resource for which the policies are to be listed.
     * @param {String} opts.action The action for which policies are to be listed.
     * @param {module:api/EnginesApi~listOryAccessControlPoliciesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/OryAccessControlPolicy>}
     */
    this.listOryAccessControlPolicies = function(flavor, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling listOryAccessControlPolicies");
      }


      var pathParams = {
        'flavor': flavor
      };
      var queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'subject': opts['subject'],
        'resource': opts['resource'],
        'action': opts['action']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = [OryAccessControlPolicy];

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/policies', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listOryAccessControlPolicyRoles operation.
     * @callback module:api/EnginesApi~listOryAccessControlPolicyRolesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/OryAccessControlPolicyRole>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * List ORY Access Control Policy Roles
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;
     * @param {Object} opts Optional parameters
     * @param {Number} opts.limit The maximum amount of policies returned.
     * @param {Number} opts.offset The offset from where to start looking.
     * @param {String} opts.member The member for which the roles are to be listed.
     * @param {module:api/EnginesApi~listOryAccessControlPolicyRolesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/OryAccessControlPolicyRole>}
     */
    this.listOryAccessControlPolicyRoles = function(flavor, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling listOryAccessControlPolicyRoles");
      }


      var pathParams = {
        'flavor': flavor
      };
      var queryParams = {
        'limit': opts['limit'],
        'offset': opts['offset'],
        'member': opts['member']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = [OryAccessControlPolicyRole];

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the removeOryAccessControlPolicyRoleMembers operation.
     * @callback module:api/EnginesApi~removeOryAccessControlPolicyRoleMembersCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Remove a member from an ORY Access Control Policy Role
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {String} id The ID of the ORY Access Control Policy Role.
     * @param {String} member The member to be removed.
     * @param {module:api/EnginesApi~removeOryAccessControlPolicyRoleMembersCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.removeOryAccessControlPolicyRoleMembers = function(flavor, id, member, callback) {
      var postBody = null;

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling removeOryAccessControlPolicyRoleMembers");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling removeOryAccessControlPolicyRoleMembers");
      }

      // verify the required parameter 'member' is set
      if (member === undefined || member === null) {
        throw new Error("Missing the required parameter 'member' when calling removeOryAccessControlPolicyRoleMembers");
      }


      var pathParams = {
        'flavor': flavor,
        'id': id,
        'member': member
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles/{id}/members/{member}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the upsertOryAccessControlPolicy operation.
     * @callback module:api/EnginesApi~upsertOryAccessControlPolicyCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OryAccessControlPolicy} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upsert an ORY Access Control Policy
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {Object} opts Optional parameters
     * @param {module:model/OryAccessControlPolicy} opts.body 
     * @param {module:api/EnginesApi~upsertOryAccessControlPolicyCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OryAccessControlPolicy}
     */
    this.upsertOryAccessControlPolicy = function(flavor, opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling upsertOryAccessControlPolicy");
      }


      var pathParams = {
        'flavor': flavor
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = OryAccessControlPolicy;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/policies', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the upsertOryAccessControlPolicyRole operation.
     * @callback module:api/EnginesApi~upsertOryAccessControlPolicyRoleCallback
     * @param {String} error Error message, if any.
     * @param {module:model/OryAccessControlPolicyRole} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upsert an ORY Access Control Policy Role
     * Roles group several subjects into one. Rules can be assigned to ORY Access Control Policy (OACP) by using the Role ID as subject in the OACP.
     * @param {String} flavor The ORY Access Control Policy flavor. Can be \&quot;regex\&quot;, \&quot;glob\&quot;, and \&quot;exact\&quot;.
     * @param {Object} opts Optional parameters
     * @param {module:model/OryAccessControlPolicyRole} opts.body 
     * @param {module:api/EnginesApi~upsertOryAccessControlPolicyRoleCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/OryAccessControlPolicyRole}
     */
    this.upsertOryAccessControlPolicyRole = function(flavor, opts, callback) {
      opts = opts || {};
      var postBody = opts['body'];

      // verify the required parameter 'flavor' is set
      if (flavor === undefined || flavor === null) {
        throw new Error("Missing the required parameter 'flavor' when calling upsertOryAccessControlPolicyRole");
      }


      var pathParams = {
        'flavor': flavor
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = OryAccessControlPolicyRole;

      return this.apiClient.callApi(
        '/engines/acp/ory/{flavor}/roles', 'PUT',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
